

#include <stdio.h>
#include <stdlib.h>
#include "ia32-decode.h"


int
main (int argc, char *argv[])
{
	FILE *			fp;
	unsigned int		n,
				bpos,
				offset,
				icount;
	unsigned char		buf[4096];
	ia32_instruction *	inst,
				inst_s;

	if (argc != 4) {
		fprintf (stderr, "usage: %s file offset instruction-count\n\n",
			argv[0]);
		exit (EXIT_FAILURE);
	}
	if (sscanf (argv[2], "0x%x", &offset) != 1) {
		fprintf (stderr, "invalid offset, give 0x%%x format\n");
		exit (EXIT_FAILURE);
	}
	if (sscanf (argv[3], "%d", &icount) != 1) {
		fprintf (stderr, "invalid count, give %%d format\n");
		exit (EXIT_FAILURE);
	}

	fp = fopen (argv[1], "rb");
	if (fp == NULL) {
		perror ("fopen");
		exit (EXIT_FAILURE);
	}

	lseek (fileno(fp), offset, SEEK_SET);
	printf("Seeking %x\n", offset);
	if (fread (buf, 1, sizeof (buf), fp) < 0) {
		perror ("fread");

		exit (EXIT_FAILURE);
	}

	bpos = 0;
	for (n = 0 ; n < icount ; ++n) {
		if (bpos > sizeof(buf))
			break;
		inst = ia32_decode_instruction (&buf[bpos], &inst_s);
		if (inst == NULL) {
			fprintf (stderr, "invalid instruction at 0x%08x\n",
				bpos + offset);
			++bpos;
			continue;
		}

		printf ("0x%08x: ", &buf[bpos + offset]);
		ia32_print (inst);
		bpos += inst->length;
	}

	fclose (fp);
	exit (EXIT_SUCCESS);
}


